/**************************************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#ifndef __MTK_OUR_GALAXY_H__
#define __MTK_OUR_GALAXY_H__
#include  "mtk_draw_struct.h"
#include  <vector>
#include  <string>


//--  ͌nS܂ł̋ (pc)
const float R_gal = 8000.0;


//---  Register
void		register_object_our_galaxy();
//---  Position
vector3d	get_our_galaxy_position();
//---  Scale
double		get_scale_our_galaxy();
//---  Label
bool		is_our_galaxy_label_visible(const mtk_draw_struct& ds);
float		get_our_galaxy_label_alpha(const mtk_draw_struct& ds);



double	get_landing_radius_our_galaxy(int idx);

//---  Draw
bool		prepare_draw_our_galaxy(const mtk_draw_struct& ds, double* pRb, double* pRh);
void		draw_our_galaxy(const mtk_draw_struct& ds, int idx, const vector3d& rpos, const double& scl);

//---  Hit-test
bool		hit_test_our_galaxy(const mtk_draw_struct& ds, const vector3d& rpos, const vector3d& nv);

//---  Info
void		make_object_info_our_galaxy(const mtk_draw_struct& ds, std::vector<std::string>& text);



#endif
