/******************************************************************************

Copyright (c) 2007   Tsunehiko Kato

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEF
Avj̕擾邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ
܂Bɂ́A\tgEFA̕gpAʁAύXAAfځAЕzATu
CZXA/܂͔̔錠Aу\tgEFA񋟂鑊ɓ
Ƃ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕ
Lڂ̂Ƃ܂B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂
񋟂܂Błۏ؂Ƃ́AiA̖ړIւ̓KAьN
QɂĂ̕ۏ؂܂݂܂AɌ肳̂ł͂܂B ҂܂͒
쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\tgEFAɋN܂
֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
*******************************************************************************/
#ifndef  __BOUNDING_BOX_H__
#define  __BOUNDING_BOX_H__
#include  "../math/vector3.h"


template  <class T>
class bbox3
{
	bool  bFirst;
public:
	T x1,y1,z1, x2,y2,z2;
public:
	bbox3() : bFirst(true), x1(0),y1(0),z1(0), x2(0),y2(0),z2(0) {};
	bool	isValid() const  { return !bFirst; }
	void	add_point(const vector3<T>& pt);
	void	merge(const bbox3<T>& bb);
	void	clear()	{ x1=y1=z1=x2=y2=z2=T(0); bFirst=true; }
};

typedef	bbox3<float>	bbox3f;
typedef	bbox3<double>	bbox3d;


template  <class T>
void
bbox3<T>::add_point(const vector3<T>& pt)
{
	if (bFirst) {
		bFirst = false;
		x1 = x2 = pt.x;
		y1 = y2 = pt.y;
		z1 = z2 = pt.z;
	} else {
		if (pt.x < x1)		x1=pt.x;
		else if (pt.x > x2)	x2=pt.x;

		if (pt.y < y1)		y1=pt.y;
		else if (pt.y > y2)	y2=pt.y;

		if (pt.z < z1)		z1=pt.z;
		else if (pt.z > z2)	z2=pt.z;
	}
}

template  <class T>
void
bbox3<T>::merge(const bbox3<T>& bb)
{
	if (!bb.isValid())	return;
	if (!isValid()) {
		*this = bb;
	} else {
		if (bb.x1 < x1)		x1 = bb.x1;
		if (bb.x2 > x2)		x2 = bb.x2;
		if (bb.y1 < y1)		y1 = bb.y1;
		if (bb.y2 > y2)		y2 = bb.y2;
		if (bb.z1 < z1)		z1 = bb.z1;
		if (bb.z2 > z2)		z2 = bb.z2;
	}
}


#endif
